package com.liang.service;

import com.liang.entity.SysRolePermission;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.Map;
import java.util.Set;

/**
 * (SysRolePermission)表服务接口
 *
 * @author makejava
 * @since 2023-02-19 21:37:39
 */
public interface SysRolePermissionService {

    /**
     * 通过ID查询单条数据
     *
     * @param roleId 主键
     * @return 实例对象
     */
    SysRolePermission queryById(Integer roleId);

    /**
     * 分页查询
     *
     * @param sysRolePermission 筛选条件
     * @param pageRequest       分页对象
     * @return 查询结果
     */
    Page<SysRolePermission> queryByPage(SysRolePermission sysRolePermission, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param sysRolePermission 实例对象
     * @return 实例对象
     */
    SysRolePermission insert(SysRolePermission sysRolePermission);

    /**
     * 修改数据
     *
     * @param sysRolePermission 实例对象
     * @return 实例对象
     */
    SysRolePermission update(SysRolePermission sysRolePermission);

    /**
     * 通过主键删除数据
     *
     * @param roleId 主键
     * @return 是否成功
     */
    boolean deleteById(Integer roleId);

    Set<String> listRolePermissionByUserId(Integer userId);

    /**
     * 角色权限更新
     *
     * @return
     */
    int doAuthorize(Integer roleId, String permIds);


    /**
     * 角色赋权，根据角色id获取权限树tree组件
     *
     * @param roleId 角色id
     * @return
     */
    Map<String, Object> listPermissionByRoleId(Integer roleId);
}
